# Auto-generated using compose2nix v0.3.1.
{ pkgs, lib, ... }:

{
  # Containers
  virtualisation.oci-containers.containers."traefik-reverse-proxy" = {
    image = "traefik:v3.3";
    volumes = [
      "/var/run/docker.sock:/var/run/docker.sock:rw"
    ];
    cmd = [ "--api.insecure=true" "--entryPoints.web.address=:8000" "--providers.docker" ];
    log-driver = "journald";
    extraOptions = [
      "--network=host"
    ];
  };

  systemd.services."docker-traefik-reverse-proxy" = {
    serviceConfig = {
      Restart = lib.mkOverride 90 "no";
    };
    partOf = [
      "docker-compose-traefik-root.target"
    ];
    wantedBy = [
      "docker-compose-traefik-root.target"
    ];
  };

  # Root service
  # When started, this will automatically create all resources and start
  # the containers. When stopped, this will teardown all resources.
  systemd.targets."docker-compose-traefik-root" = {
    unitConfig = {
      Description = "Root target generated by compose2nix.";
    };
    wantedBy = [ "multi-user.target" ];
  };
}
